unit UfTableAdd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Grids, StdCtrls,db,dbtables, UAspFileDataSet, FileCtrl,
  Menus, ExtCtrls, ValEdit,DBClient;

type
  TfTableAdd = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Database1: TDatabase;
    SchemaGrid2: TStringGrid;
    TabSheet3: TTabSheet;
    SchemaGrid3: TStringGrid;
    Panel1: TPanel;
    SchemaGrid: TStringGrid;
    Label4: TLabel;
    EdTablePath: TEdit;
    Label3: TLabel;
    EdTableName: TEdit;
    Button3: TButton;
    Button1: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    cbAliasList: TComboBox;
    Label2: TLabel;
    EdBDEtbName: TEdit;
    tbList: TListBox;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    EdFdNum: TLabel;
    Label6: TLabel;
    EdRecNum: TLabel;
    Label8: TLabel;
    EdFdSizeNum: TLabel;
    ChkInsertAllData: TCheckBox;
    Label7: TLabel;
    EdAddRecNo: TLabel;
    Button2: TButton;
    Panel3: TPanel;
    Label9: TLabel;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    EdAsptbName: TEdit;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    EdAspFdNum: TLabel;
    Label12: TLabel;
    EdAspRecNum: TLabel;
    Label14: TLabel;
    EdAspFdSizeNum: TLabel;
    ChkInsertAspAllData: TCheckBox;
    Label16: TLabel;
    EdAspAddRecNo: TLabel;
    Button4: TButton;
    Label11: TLabel;
    TabSheet4: TTabSheet;
    SchemaGrid4: TStringGrid;
    DriveComboBox2: TDriveComboBox;
    DirectoryListBox2: TDirectoryListBox;
    FileListBox2: TFileListBox;
    Label13: TLabel;
    Button5: TButton;
    Label15: TLabel;
    Label17: TLabel;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Label18: TLabel;
    Label19: TLabel;
    OpenDialog1: TOpenDialog;
    TabSheet5: TTabSheet;
    DriveComboBox3: TDriveComboBox;
    Label20: TLabel;
    DirectoryListBox3: TDirectoryListBox;
    MidasTbList: TFileListBox;
    SchemaGrid5: TStringGrid;
    Label21: TLabel;
    MidasNewTableName: TEdit;
    ChkInsertMidasAllData: TCheckBox;
    Label22: TLabel;
    EdMidasAddRecNo: TLabel;
    Button9: TButton;
    Label23: TLabel;
    EdMidasFdNum: TLabel;
    Label24: TLabel;
    EdMidasRecNum: TLabel;
    Label25: TLabel;
    EdFileFilter: TEdit;
    Button10: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SchemaGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure SchemaGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure SchemaGrid2SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure SchemaGrid2GetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure Button1Click(Sender: TObject);
    procedure cbAliasListChange(Sender: TObject);
    procedure tbListClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FileListBox1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FileListBox2Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure MidasTbListClick(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ClearSchemaGrid1;
    procedure ClearSchemaGrid2;
    procedure ClearSchemaGrid3;
    procedure ClearSchemaGrid5;
  end;

var
  fTableAdd: TfTableAdd;

implementation

{$R *.dfm}

uses UfDbLoginDlg;

var gFieldCount:integer;

function TrimTableName(inFileStr:string):string;
var i:integer;
    rstr:string;
begin
  result := '';  rstr := '';
  for i := 1 to Length(inFileStr) do
    if(inFileStr[i] = '.')then Break
    else rstr := rstr+inFileStr[i];
  result := rstr;
end;//func...end!!

procedure TfTableAdd.FormCreate(Sender: TObject);
var FieldAddSuccess:OleVariant;
begin
  SchemaGrid.Cells[0,0] := 'W (20ӭ^rH)';
  SchemaGrid.Cells[1,0] := 'ƪ';
  SchemaGrid.Cells[2,0] := 'iHS';
  SchemaGrid.Cells[3,0] := '@Key';
  SchemaGrid.Cells[4,0] := '컡';
  //----------------------------------------------------
  SchemaGrid2.Cells[0,0] := 'W (20ӭ^rH)';
  SchemaGrid2.Cells[1,0] := 'ƪ';
  SchemaGrid2.Cells[2,0] := 'iHS';
  SchemaGrid2.Cells[3,0] := '@Key';
  SchemaGrid2.Cells[4,0] := '컡';
  //----------------------------------------------------
  SchemaGrid3.Cells[0,0] := 'W (20ӭ^rH)';
  SchemaGrid3.Cells[1,0] := 'ƪ';
  SchemaGrid3.Cells[2,0] := 'iHS';
  SchemaGrid3.Cells[3,0] := '@Key';
  SchemaGrid3.Cells[4,0] := '컡';
  //----------------------------------------------------
  SchemaGrid4.Cells[0,0] := 'W (20ӭ^rH)';
  SchemaGrid4.Cells[1,0] := '}lrIndex';
  SchemaGrid4.Cells[2,0] := 'rIndex';
  SchemaGrid4.Cells[3,0] := 'յG';
  //----------------------------------------------------
  SchemaGrid5.Cells[0,0] := 'W (20ӭ^rH)';
  SchemaGrid5.Cells[1,0] := 'ƪ';
  SchemaGrid5.Cells[2,0] := 'iHS';
  SchemaGrid5.Cells[3,0] := '@Key';
  SchemaGrid5.Cells[4,0] := '컡';
  //----------------------------------------------------
  cbAliasList.Items.Clear;
  tbList.Items.Clear;
  Session.GetAliasNames(cbAliasList.Items);

  (*
  if(FileExists('TableRef.XDB') = FALSE)then
  with TableRefDataSet do
    begin
      RecDataSet.AddNewField('ƪs',13,TRUE,FALSE,FieldAddSuccess);
      RecDataSet.AddNewField('ƪW',20,FALSE,FALSE,FieldAddSuccess);
      RecDataSet.AddNewField('ƪ',13,FALSE,FALSE,FieldAddSuccess);
      RecDataSet.SaveSchema('TableRef');
    end;//if...end!!
  TableRefDataSet.RecDataSet.LoadSchema('TableRef.SFD');
  TableRefDataSet.Active := TRUE;
  TableRefGrid.DataSource := TableRefDs;
  *)
  
end;

procedure TfTableAdd.SchemaGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var inValue:integer;
begin
  if(ACol = 1)and(Value <> '')then
    begin
      inValue := -1;
      inValue := StrToIntDef(Value,-1);
      if(inValue <= 0)then
        begin
          ShowMessage('( ƪ )-->J~!!ЭsJ!!');
          SchemaGrid.Col := ACol;
        end;//if...end!!
    end;//if...end!!
end;

procedure TfTableAdd.SchemaGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin
  if(TStringGrid(Sender).Cells[0,ARow] <> '')then
    begin
      if(ACol = 2)and(Value = '')then
       if(ARow = 1)then Value := 'No' else Value := 'Yes';

      if(ACol = 3)and(Value = '')then
        if(ARow = 1)then Value := 'Yes' else Value := 'No';
    end;//if...end!!    
end;

procedure TfTableAdd.SchemaGrid2SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var inValue:integer;
begin
  if(ACol = 1)and(Value <> '')then
    begin
      inValue := -1;
      inValue := StrToIntDef(Value,-1);
      if(inValue <= 0)then
        begin
          ShowMessage('( ƪ )-->J~!!ЭsJ!!');
          SchemaGrid2.Col := ACol;
        end;//if...end!!
    end;//if...end!!
end;  

procedure TfTableAdd.SchemaGrid2GetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin
  if(ACol = 2)and(Value = '')then
    if(ARow = 1)then Value := 'No' else Value := 'Yes';

  if(ACol = 3)and(Value = '')then
    if(ARow = 1)then Value := 'Yes' else Value := 'No';
end;

procedure TfTableAdd.Button1Click(Sender: TObject);
var i:integer;
    SchemaStr:string;
    FdStr,FdSize,FdCanNull,FdIsKey:string;
    tmpDataSet:TAspFileDataSet;
begin
  if(trim(EdTablePath.Text) = '')then Exit;
  if(trim(EdTableName.Text) = '')then Exit;
  SchemaStr := '';
  for i := 1 to SchemaGrid.RowCount-1 do
    begin
      if(SchemaGrid.Cells[0,i] = '')then break
      else
        begin
          FdStr     := '';
          FdSize    := '';
          FdCanNull := 'N';
          FdIsKey   := 'N';
          if(SchemaGrid.Cells[2,i] = 'Yes')then FdCanNull := 'Y';
          if(SchemaGrid.Cells[3,i] = 'Yes')then
            begin
              FdIsKey   := 'Y';
              FdCanNull := 'N';
            end;//if...end!!
          FdStr  := SchemaGrid.Cells[0,i];
          FdSize := SchemaGrid.Cells[1,i];
          SchemaStr := SchemaStr+FdCanNull+'.'+FdIsKey+'.'+FdStr+'.'+FdSize+',';
        end;//else...end!!
    end;//for...i...end!!
  //----------------------------------------------------------------------------
  try
    tmpDataSet := TAspFileDataSet.Create(nil);

    tmpDataSet.RecDataSet.CompressData := TRUE;
    tmpDataSet.RecDataSet.EncryptData  := TRUE;
     
    tmpDataSet.AccessFile := EdTablePath.Text+'\'
                            +TrimTableName(EdTableName.Text)+'.XDB';
    tmpDataSet.AccessUser := '1234';
    tmpDataSet.RecDataSet.InitFieldsWithSchemaStr(SchemaStr);
    if(tmpDataSet.RecDataSet.FieldCount > 0)then
      begin
        tmpDataSet.RecDataSet.SaveSchema( EdTablePath.Text
                                         +'\'+TrimTableName(EdTableName.Text)+'.SFD');
        ShowMessage('ƪsW!!');
      end;//if...end!!
  finally
    tmpDataSet.Active := FALSE;
    tmpDataSet.Free;
  end;//try....end!!
end;

procedure TfTableAdd.cbAliasListChange(Sender: TObject);
begin
  if(trim(cbAliasList.Text) = '')then Exit;
  DataBase1.Connected := FALSE;
  tbList.Items.Clear;
  Database1.AliasName := cbAliasList.Text;
  Database1.DatabaseName := 'TESTDB';
  //debug!! ShowMessage(Database1.Params.CommaText);
  DbLoginDlg.ShowModal;
  if(DbLoginDlg.GetUserName <> '')and(DbLoginDlg.GetPassword <> '')then
    begin
      Database1.Params.Clear;
      Database1.Params.Add('USER NAME='+DbLoginDlg.GetUserName);
      Database1.Params.Add('PASSWORD='+DbLoginDlg.GetPassword);
      Database1.LoginPrompt := FALSE;
      //debug ShowMessage(Database1.Params.CommaText);
      DataBase1.Connected := TRUE;
      DataBase1.Session.GetTableNames(Database1.DatabaseName,'',TRUE,FALSE,tbList.Items);
    end;//if...end!!
end;

procedure TfTableAdd.ClearSchemaGrid1;
var i,j:integer;
begin
  for i := 0 to SchemaGrid.ColCount-1 do
  for j := 1 to SchemaGrid.RowCount-1 do
    SchemaGrid.Cells[i,j] := '';
end;

procedure TfTableAdd.ClearSchemaGrid2;
var i,j:integer;
begin
  for i := 0 to SchemaGrid2.ColCount-1 do
  for j := 1 to SchemaGrid2.RowCount-1 do
    SchemaGrid2.Cells[i,j] := '';
end;

procedure TfTableAdd.ClearSchemaGrid3;
var i,j:integer;
begin
  for i := 0 to SchemaGrid3.ColCount-1 do
  for j := 1 to SchemaGrid3.RowCount-1 do
    SchemaGrid3.Cells[i,j] := '';
end;

procedure TfTableAdd.tbListClick(Sender: TObject);
var tmptb:TTable;
    i,FdDtSize:integer;
begin
  if(tbList.ItemIndex >= 0)then
    begin
      EdAddRecNo.Caption := '0';
      EdBDEtbName.Text   := ''; 
      EdBDEtbName.Text   := tbList.Items[tbList.ItemIndex];
      try
        tmptb := TTable.Create(nil);
        tmptb.DatabaseName := Database1.DataBaseName;
        tmptb.TableName    := EdBDEtbName.Text;
        tmptb.Active := TRUE;
        EdFdNum.Caption  := IntToStr(tmptb.FieldCount);
        EdRecNum.Caption := IntToStr(tmptb.RecordCount);
        gFieldCount      := tmptb.FieldCount;
        ClearSchemaGrid2;
        FdDtSize         := 0;
        for i := 0 to tmptb.FieldCount-1 do
          begin
            SchemaGrid2.Cells[0,i+1] := tmptb.Fields[i].FieldName;
            SchemaGrid2.Cells[1,i+1] := IntToStr(tmptb.Fields[i].DataSize);
            FdDtSize := FdDtSize + tmptb.Fields[i].DataSize;

            if(tmptb.Fields[i].Required = TRUE)then
              SchemaGrid2.Cells[2,i+1] := 'No'
            else SchemaGrid2.Cells[2,i+1] := 'Yes';

            if(tmptb.Fields[i].IsIndexField = TRUE)then
              begin
                SchemaGrid2.Cells[3,i+1] := 'Yes';
                SchemaGrid2.Cells[2,i+1] := 'No';
              end
            else SchemaGrid2.Cells[3,i+1] := 'No';
          end;//for...i...end!!
        EdFdSizeNum.Caption := IntToStr(FdDtSize);
      finally
        tmptb.Close;
        tmptb.Free;
      end;//try...end!!
    end;//if...end!!
end;

procedure TfTableAdd.Button2Click(Sender: TObject);
var i,AddcRecNum:integer;
    SchemaStr:string;
    FdStr,FdSize,FdCanNull,FdIsKey:string;
    tmpDataSet:TAspFileDataSet;
    tmptb:TQuery;
    recIsAdd:OleVariant;
    procedure Delay;
    var id:integer;
        str:string;
    begin
      
    end;
begin
  if(trim(EdTablePath.Text) = '')then Exit;
  if(trim(EdBDEtbName.Text) = '')then Exit;
  SchemaStr := '';
  for i := 1 to gFieldCount do
    begin
      if(SchemaGrid2.Cells[0,i] = '')then break
      else
        begin
          FdStr     := '';
          FdSize    := '';
          FdCanNull := 'N';
          FdIsKey   := 'N';
          if(SchemaGrid2.Cells[2,i] = 'Yes')then FdCanNull := 'Y';
          if(SchemaGrid2.Cells[3,i] = 'Yes')then
            begin
              FdIsKey   := 'Y';
              FdCanNull := 'N';
            end;//if...end!!
          FdStr  := SchemaGrid2.Cells[0,i];
          FdSize := SchemaGrid2.Cells[1,i];
          SchemaStr := SchemaStr+FdCanNull+'.'+FdIsKey+'.'+FdStr+'.'+FdSize+',';
        end;//else...end!!
    end;//for...i...end!!
  //debug !! ShowMessage('Schema  = '+IntToStr(Length(SchemaStr)));
  //----------------------------------------------------------------------------
  try
    tmpDataSet := TAspFileDataSet.Create(nil);

    tmpDataSet.RecDataSet.CompressData := TRUE;
    tmpDataSet.RecDataSet.EncryptData  := TRUE;

    tmpDataSet.AccessFile := TrimTableName(EdBDEtbName.Text)+'.XDB';
    tmpDataSet.AccessUser := '1234';
    tmpDataSet.RecDataSet.InitFieldsWithSchemaStr(SchemaStr);
    if(tmpDataSet.RecDataSet.FieldCount > 0)then
      begin
        //ShowMessage('Field Count = '+IntToStr(tmpDataSet.RecDataSet.FieldCount));
        tmpDataSet.RecDataSet.SaveSchema(EdTablePath.Text+'\'+TrimTableName(EdBDEtbName.Text)+'.SFD');
        if(ChkInsertAllData.Checked = FALSE)then ShowMessage('ƪsW!!')
        else
          begin
            ShowMessage('ƪsW!! }lಾ !!');
            tmptb := TQuery.Create(nil);
            tmptb.DatabaseName := DataBase1.DataBaseName;
            tmptb.SQL.Clear;
            tmptb.SQL.Add('select * from '+EdBDEtbName.Text);
            tmptb.Active := TRUE;
            ///tmpDataSet.AccessFile := EdTablePath.Text+'\'+TrimTableName(EdBDEtbName.Text)+'.XDB';

            tmpDataSet.SchemaFileName := EdTablePath.Text+'\'+TrimTableName(EdBDEtbName.Text)+'.SFD';

            tmpDataSet.Active := TRUE;
            AddcRecNum := 0;
            EdAddRecNo.Caption := '0';
            while(tmptb.Eof = FALSE)do
              begin
                Application.ProcessMessages;
                tmpDataSet.RecDataSet.RecInsert;
                for i := 0 to tmpDataSet.RecDataSet.FieldCount-1 do
                  begin
                    Delay;
                    Application.ProcessMessages;
                    FdStr := tmpDataSet.RecDataSet.FieldName[i];
                    if(UpperCase(tmptb.Fields[i].FieldName)
                       <> UpperCase(fdstr))then Continue
                    else
                      if(tmptb.FieldByName(FdStr).IsNull = FALSE)then
                        tmpDataSet.RecDataSet.FieldByName[FdStr]
                          := tmptb.FieldByName(FdStr).AsString;
                  end;//for...i...end!!
                try
                  tmpDataSet.RecDataSet.RecPost(recIsAdd);
                except
                end;
                if(recIsAdd = TRUE)then AddcRecNum := AddcRecNum+1;
                EdAddRecNo.Caption := IntToStr(AddcRecNum);
                tmptb.Next;
              end;//while...end!!
          end;//else...end!!
      end;//if...end!!
  finally
    tmpDataSet.Active := FALSE;
    tmpDataSet.Free;
    if(tmptb <> nil)then
      begin
        tmptb.Active := FALSE;
        tmptb.Free;
      end;//if...end!!  
  end;//try....end!!
end;

procedure TfTableAdd.Button3Click(Sender: TObject);
begin
  ClearSchemaGrid1;
end;

procedure TfTableAdd.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Database1.Connected := FALSE;
end;

procedure TfTableAdd.FileListBox1Click(Sender: TObject);
var tmptb:TAspFileDataSet;
    i,FdDtSize:integer;
    tmpfdstr:string;
begin
  if(FileListBox1.ItemIndex >= 0)then
    begin
      EdAspAddRecNo.Caption := '0';
      EdAsptbName.Text   := '';
      EdAsptbName.Text   := FileListBox1.Items[FileListBox1.ItemIndex];
      try
        tmptb := TAspFileDataSet.Create(nil);
        tmptb.AccessFile := EdAsptbName.Text;
        tmptb.AccessUser := 'Admin';
        tmptb.Active := TRUE;
        EdAspFdNum.Caption  := IntToStr(tmptb.RecDataSet.FieldCount);
        EdAspRecNum.Caption := IntToStr(tmptb.RecDataSet.RecordCount);
        gFieldCount      := tmptb.RecDataSet.FieldCount;
        ClearSchemaGrid3;
        FdDtSize         := 0;
        for i := 0 to tmptb.RecDataSet.FieldCount-1 do
          begin
            tmpfdstr := '';
            tmpfdstr := tmptb.RecDataSet.FieldName[i];
            SchemaGrid3.Cells[0,i+1] := tmpfdstr;
            SchemaGrid3.Cells[1,i+1] := IntToStr(tmptb.RecDataSet.FieldDataSize[tmpfdstr]);
            FdDtSize := FdDtSize + tmptb.RecDataSet.FieldDataSize[tmpfdstr];

            if(tmptb.RecDataSet.IsKeyField[tmpfdstr] = TRUE)then
              SchemaGrid3.Cells[2,i+1] := 'No'
            else SchemaGrid3.Cells[2,i+1] := 'Yes';

            if(tmptb.RecDataSet.IsKeyField[tmpfdstr] = TRUE)then
              SchemaGrid3.Cells[3,i+1] := 'Yes'
            else SchemaGrid3.Cells[3,i+1] := 'No';
          end;//for...i...end!!
        EdAspFdSizeNum.Caption := IntToStr(FdDtSize);
      finally
        tmptb.RecDataSet.Close;
        tmptb.Free;
      end;//try...end!!
    end;//if...end!!
end;

procedure TfTableAdd.Button4Click(Sender: TObject);
var i,AddcRecNum:integer;
    SchemaStr,FilePathStr:string;
    FdStr,FdSize,FdCanNull,FdIsKey:string;
    tmpDataSet:TAspFileDataSet;
    tmptb:TAspFileDataSet;
    recIsAdd:OleVariant;
begin
  if(trim(EdAsptbName.Text) = '')then Exit;
  FilePathStr := FileListBox1.Directory;
  SchemaStr := '';
  gFieldCount := SchemaGrid3.RowCount-1;
  for i := 1 to gFieldCount do
    begin
      if(SchemaGrid3.Cells[0,i] = '')then break
      else
        begin
          FdStr     := '';
          FdSize    := '';
          FdCanNull := 'N';
          FdIsKey   := 'N';
          if(SchemaGrid3.Cells[2,i] = 'Yes')then FdCanNull := 'Y';
          if(SchemaGrid3.Cells[3,i] = 'Yes')then
            begin
              FdIsKey   := 'Y';
              FdCanNull := 'N';
            end;//if...end!!
          FdStr  := SchemaGrid3.Cells[0,i];
          FdSize := SchemaGrid3.Cells[1,i];
          SchemaStr := SchemaStr+FdCanNull+'.'+FdIsKey+'.'+FdStr+'.'+FdSize+',';
        end;//else...end!!
    end;//for...i...end!!
  //debug !! ShowMessage('Schema  = '+IntToStr(Length(SchemaStr)));
  //----------------------------------------------------------------------------
  try
    tmpDataSet := TAspFileDataSet.Create(nil);

    tmpDataSet.RecDataSet.CompressData := TRUE;
    tmpDataSet.RecDataSet.EncryptData  := TRUE;

    tmpDataSet.AccessFile := EdAsptbName.Text;
    tmpDataSet.AccessUser := '1234';
    tmpDataSet.RecDataSet.InitFieldsWithSchemaStr(SchemaStr);
    if(tmpDataSet.RecDataSet.FieldCount > 0)then
      begin
        //ShowMessage('Field Count = '+IntToStr(tmpDataSet.RecDataSet.FieldCount));
        tmpDataSet.RecDataSet.SaveSchema(FilePathStr+'\'+TrimTableName(EdAsptbName.Text)+'.SFD');
        if(ChkInsertAspAllData.Checked = FALSE)then ShowMessage('ƪsW!!')
        else
          begin
            ShowMessage('ƪsW!! }lಾ !!');
            tmptb := TAspFileDataSet.Create(nil);
            tmptb.AccessFile := FileListBox1.FileName;
            tmptb.AccessUser := 'Expoler';
            tmptb.Active     := TRUE;
            tmpDataSet.AccessFile := FilePathStr+'\'+EdAsptbName.Text;
            tmpDataSet.Active := TRUE;
            AddcRecNum := 0;
            EdAspAddRecNo.Caption := '0';
            while(tmptb.RecDataSet.IsEof = FALSE)do
              begin
                Application.ProcessMessages;
                tmpDataSet.RecDataSet.RecInsert;
                for i := 0 to tmptb.RecDataSet.FieldCount-1 do
                  begin
                    Application.ProcessMessages;
                    FdStr := '';
                    FdStr := tmptb.RecDataSet.FieldName[i];
                    if(tmpDataSet.RecDataSet.IsThisFieldExists(FdStr) = TRUE)then
                      tmpDataSet.RecDataSet.FieldByName[FdStr]
                        := tmptb.RecDataSet.FieldByName[FdStr];
                  end;//for...i...end!!
                try
                  tmpDataSet.RecDataSet.RecPost(recIsAdd);
                except
                end;
                if(recIsAdd = TRUE)then AddcRecNum := AddcRecNum+1;
                EdAspAddRecNo.Caption := IntToStr(AddcRecNum);
                tmptb.RecDataSet.RecNext;
              end;//while...end!!
          end;//else...end!!
      end;//if...end!!
  finally
    tmpDataSet.Active := FALSE;
    tmpDataSet.Free;
    if(tmptb <> nil)then
      begin
        tmptb.Active := FALSE;
        tmptb.Free;
      end;//if...end!!  
  end;//try....end!!
end;

procedure TfTableAdd.FileListBox2Click(Sender: TObject);
var tmpFile:TextFile;
    str:string;
    RecCount:integer;
begin
  //FileListBox2.Cursor :=
  AssignFile(tmpFile,FileListBox2.FileName);
  Reset(tmpFile);
  RecCount := 0;
  while not Eof(tmpFile) do
    begin
      Readln(tmpFile,str);
      RecCount := RecCount+1;
    end;//while...end!!
  CloseFile(tmpFile);
  Label19.Caption := IntToStr(RecCount);
  //FileListBox2.Cursor :=
end;

procedure TfTableAdd.Button9Click(Sender: TObject);
var i,AddcRecNum:integer;
    SchemaStr,FilePathStr,ValueStr:string;
    FdStr,FdSize,FdCanNull,FdIsKey:string;
    tmpDataSet:TAspFileDataSet;
    tmptb:TClientDataSet;
    recIsAdd:OleVariant;
begin
  if(trim(MidasNewTableName.Text) = '')then Exit;
  FilePathStr := FileListBox1.Directory;
  SchemaStr := '';
  gFieldCount := SchemaGrid5.RowCount-1;
  for i := 1 to gFieldCount do
    begin
      if(SchemaGrid5.Cells[0,i] = '')then break
      else
        begin
          FdStr     := '';
          FdSize    := '';
          FdCanNull := 'N';
          FdIsKey   := 'N';
          if(SchemaGrid5.Cells[2,i] = 'Yes')then FdCanNull := 'Y';
          if(SchemaGrid5.Cells[3,i] = 'Yes')then
            begin
              FdIsKey   := 'Y';
              FdCanNull := 'N';
            end;//if...end!!
          FdStr  := SchemaGrid5.Cells[0,i];
          FdSize := SchemaGrid5.Cells[1,i];
          SchemaStr := SchemaStr+FdCanNull+'.'+FdIsKey+'.'+FdStr+'.'+FdSize+',';
        end;//else...end!!
    end;//for...i...end!!
  //debug !! ShowMessage('Schema  = '+IntToStr(Length(SchemaStr)));
  //----------------------------------------------------------------------------
  try
    tmpDataSet := TAspFileDataSet.Create(nil);
    tmpDataSet.RecDataSet.CompressData := TRUE;
    tmpDataSet.RecDataSet.EncryptData  := TRUE;
    //----------------------------------------------
    tmpDataSet.AccessFile := MidasNewTableName.Text;
    tmpDataSet.AccessUser := '1234';
    tmpDataSet.RecDataSet.InitFieldsWithSchemaStr(SchemaStr);
    if(tmpDataSet.RecDataSet.FieldCount > 0)then
      begin
        //ShowMessage('Field Count = '+IntToStr(tmpDataSet.RecDataSet.FieldCount));
        tmpDataSet.RecDataSet.SaveSchema(FilePathStr+'\'+TrimTableName(MidasNewTableName.Text)+'.SFD');
        if(ChkInsertMidasAllData.Checked = FALSE)then ShowMessage('ƪsW!!')
        else
          begin
            ShowMessage('ƪsW!! }lಾ !!');
            tmptb := TClientDataSet.Create(nil);
            tmptb.LoadFromFile(MidasTbList.FileName);
            tmptb.Active := TRUE;
            tmpDataSet.AccessFile := FilePathStr+'\'
                                    +TrimTableName(MidasNewTableName.Text)+'.XDB';
            tmpDataSet.Active := TRUE;
            AddcRecNum := 0;
            EdAspAddRecNo.Caption := '0';
            while(tmptb.Eof = FALSE)do
              begin
                Application.ProcessMessages;
                tmpDataSet.RecDataSet.RecInsert;
                for i := 0 to tmptb.FieldCount-1 do
                  begin
                    Application.ProcessMessages;
                    FdStr := '';
                    FdStr := tmptb.Fields[i].FieldName;
                    ValueStr := '';
                    ValueStr := tmptb.FieldByName(FdStr).AsString;
                    if(ValueStr = '')then ValueStr := '*';
                    if(tmpDataSet.RecDataSet.IsThisFieldExists(FdStr) = TRUE)then
                      tmpDataSet.RecDataSet.FieldByName[FdStr] := ValueStr;
                  end;//for...i...end!!
                try
                  tmpDataSet.RecDataSet.RecPost(recIsAdd);
                except
                end;
                if(recIsAdd = TRUE)then AddcRecNum := AddcRecNum+1;
                EdMidasAddRecNo.Caption := IntToStr(AddcRecNum);
                tmptb.Next;
              end;//while...end!!
          end;//else...end!!
      end;//if...end!!
  finally
    tmpDataSet.Active := FALSE;
    tmpDataSet.Free;
    if(tmptb <> nil)then
      begin
        tmptb.Active := FALSE;
        tmptb.Free;
      end;//if...end!!
  end;//try....end!!
end;


procedure TfTableAdd.MidasTbListClick(Sender: TObject);
var tmptb:TClientDataSet;
    i,FdDtSize:integer;
begin
  if(MidasTbList.ItemIndex >= 0)then
    begin
      EdMidasAddRecNo.Caption := '0';
      MidasNewTableName.Text  := '';
      MidasNewTableName.Text  := MidasTbList.Items[MidasTbList.ItemIndex];
      try
        tmptb := TClientDataSet.Create(nil);
        tmptb.LoadFromFile(MidasTbList.FileName);
        tmptb.Active := TRUE;
        EdMidasFdNum.Caption  := IntToStr(tmptb.FieldCount);
        EdMidasRecNum.Caption := IntToStr(tmptb.RecordCount);
        gFieldCount := tmptb.FieldCount;
        ClearSchemaGrid5;
        FdDtSize         := 0;
        for i := 0 to tmptb.FieldCount-1 do
          begin
            SchemaGrid5.Cells[0,i+1] := tmptb.Fields[i].FieldName;
            SchemaGrid5.Cells[1,i+1] := IntToStr(tmptb.Fields[i].DataSize);
            FdDtSize := FdDtSize + tmptb.Fields[i].DataSize;

            if(tmptb.Fields[i].Required = TRUE)then
              SchemaGrid5.Cells[2,i+1] := 'No'
            else SchemaGrid5.Cells[2,i+1] := 'Yes';

            if(tmptb.Fields[i].IsIndexField = TRUE)then
              begin
                SchemaGrid5.Cells[3,i+1] := 'Yes';
                SchemaGrid5.Cells[2,i+1] := 'No';
              end
            else SchemaGrid5.Cells[3,i+1] := 'No';
          end;//for...i...end!!
        EdFdSizeNum.Caption := IntToStr(FdDtSize);
      finally
        tmptb.Close;
        tmptb.Free;
      end;//try...end!!
    end;//if...end!!
end;

procedure TfTableAdd.ClearSchemaGrid5;
var i,j:integer;
begin
  for i := 0 to SchemaGrid5.ColCount-1 do
  for j := 1 to SchemaGrid5.RowCount-1 do
    SchemaGrid5.Cells[i,j] := '';
end;

procedure TfTableAdd.Button10Click(Sender: TObject);
begin
  MidasTbList.Mask := EdFileFilter.Text;
end;

end.
